| SX126x-Arduino 2.0.1

Macros | Functions | Variables
Region EU433

Implementation according to LoRaWAN Specification v1.0.2. More...

## Macros
#define | EU433_MAX_NB_CHANNELS 16
#define | EU433_NUMB_DEFAULT_CHANNELS 3
#define | EU433_NUMB_CHANNELS_CF_LIST 5
#define | EU433_TX_MIN_DATARATE DR_0
#define | EU433_TX_MAX_DATARATE DR_7
#define | EU433_RX_MIN_DATARATE DR_0
#define | EU433_RX_MAX_DATARATE DR_7
#define | EU433_DEFAULT_DATARATE DR_0
#define | EU433_MIN_RX1_DR_OFFSET 0
#define | EU433_MAX_RX1_DR_OFFSET 5
#define | EU433_DEFAULT_RX1_DR_OFFSET 0
#define | EU433_MIN_TX_POWER TX_POWER_5
#define | EU433_MAX_TX_POWER TX_POWER_0
#define | EU433_DEFAULT_TX_POWER TX_POWER_0
#define | EU433_DEFAULT_MAX_EIRP 12.15f
#define | EU433_DEFAULT_ANTENNA_GAIN 2.15f
#define | EU433_ADR_ACK_LIMIT 64
#define | EU433_ADR_ACK_DELAY 32
#define | EU433_DUTY_CYCLE_ENABLED 1
#define | EU433_MAX_RX_WINDOW 3000
#define | EU433_RECEIVE_DELAY1 1000
#define | EU433_RECEIVE_DELAY2 2000
#define | EU433_JOIN_ACCEPT_DELAY1 5000
#define | EU433_JOIN_ACCEPT_DELAY2 6000
#define | EU433_MAX_FCNT_GAP 16384
#define | EU433_ACKTIMEOUT 2000
#define | EU433_ACK_TIMEOUT_RND 1000
#define | EU433_RX_WND_2_FREQ 434665000
#define | EU433_RX_WND_2_DR DR_0
#define | EU433_MAX_NB_BANDS 1
#define | EU433_BAND0
#define | EU433_LC1
#define | EU433_LC2
#define | EU433_LC3
#define | EU433_JOIN_CHANNELS (uint16_t)(LC(1) | LC(2) | LC(3))

## Functions
PhyParam_t | RegionEU433GetPhyParam (GetPhyParams_t *getPhy)
| The function gets a value of a specific phy attribute. More...
void | RegionEU433SetBandTxDone (SetBandTxDoneParams_t *txDone)
| Updates the last TX done parameters of the current channel. More...
void | RegionEU433InitDefaults (InitType_t type)
| Initializes the channels masks and the channels. More...
bool | RegionEU433Verify (VerifyParams_t *verify, PhyAttribute_t phyAttribute)
| Verifies a parameter. More...
void | RegionEU433ApplyCFList (ApplyCFListParams_t *applyCFList)
| The function parses the input buffer and sets up the channels of the CF list. More...
bool | RegionEU433ChanMaskSet (ChanMaskSetParams_t *chanMaskSet)
| Sets a channels mask. More...
bool | RegionEU433AdrNext (AdrNextParams_t *adrNext, int8_t *drOut, int8_t *txPowOut, uint32_t *adrAckCounter)
| Calculates the next datarate to set, when ADR is on or off. More...
void | RegionEU433ComputeRxWindowParameters (int8_t datarate, uint8_t minRxSymbols, uint32_t rxError, RxConfigParams_t *rxConfigParams)
bool | RegionEU433RxConfig (RxConfigParams_t *rxConfig, int8_t *datarate)
| Configuration of the RX windows. More...
bool | RegionEU433TxConfig (TxConfigParams_t *txConfig, int8_t *txPower, TimerTime_t *txTimeOnAir)
| TX configuration. More...
uint8_t | RegionEU433LinkAdrReq (LinkAdrReqParams_t *linkAdrReq, int8_t *drOut, int8_t *txPowOut, uint8_t *nbRepOut, uint8_t *nbBytesParsed)
| The function processes a Link ADR Request. More...
uint8_t | RegionEU433RxParamSetupReq (RxParamSetupReqParams_t *rxParamSetupReq)
| The function processes a RX Parameter Setup Request. More...
uint8_t | RegionEU433NewChannelReq (NewChannelReqParams_t *newChannelReq)
| The function processes a Channel Request. More...
int8_t | RegionEU433TxParamSetupReq (TxParamSetupReqParams_t *txParamSetupReq)
| The function processes a TX ParamSetup Request. More...
uint8_t | RegionEU433DlChannelReq (DlChannelReqParams_t *dlChannelReq)
| The function processes a DlChannel Request. More...
int8_t | RegionEU433AlternateDr (AlternateDrParams_t *alternateDr)
| Alternates the datarate of the channel for the join request. More...
void | RegionEU433CalcBackOff (CalcBackOffParams_t *calcBackOff)
| Calculates the back-off time. More...
bool | RegionEU433NextChannel (NextChanParams_t *nextChanParams, uint8_t *channel, TimerTime_t *time, TimerTime_t *aggregatedTimeOff)
| Searches and set the next random available channel. More...
LoRaMacStatus_t | RegionEU433ChannelAdd (ChannelAddParams_t *channelAdd)
| Adds a channel. More...
bool | RegionEU433ChannelsRemove (ChannelRemoveParams_t *channelRemove)
| Removes a channel. More...
void | RegionEU433SetContinuousWave (ContinuousWaveParams_t *continuousWave)
| Sets the radio into continuous wave mode. More...
uint8_t | RegionEU433ApplyDrOffset (uint8_t downlinkDwellTime, int8_t dr, int8_t drOffset)
| Computes new datarate according to the given offset. More...

## Variables
static const uint8_t | DataratesEU433 [] = {12, 11, 10, 9, 8, 7, 7, 50}
static const uint32_t | BandwidthsEU433 [] = {125000, 125000, 125000, 125000, 125000, 125000, 250000, 0}
static const uint8_t | MaxPayloadOfDatarateEU433 [] = {51, 51, 51, 115, 242, 242, 242, 242}
static const uint8_t | MaxPayloadOfDatarateRepeaterEU433 [] = {51, 51, 51, 115, 222, 222, 222, 222}

## Detailed Description

Implementation according to LoRaWAN Specification v1.0.2.

## Macro Definition Documentation

## ◆ EU433_MAX_NB_CHANNELS

#define EU433_MAX_NB_CHANNELS 16

LoRaMac maximum number of channels

## ◆ EU433_NUMB_DEFAULT_CHANNELS

#define EU433_NUMB_DEFAULT_CHANNELS 3

Number of default channels

## ◆ EU433_NUMB_CHANNELS_CF_LIST

#define EU433_NUMB_CHANNELS_CF_LIST 5

Number of channels to apply for the CF list

## ◆ EU433_TX_MIN_DATARATE

#define EU433_TX_MIN_DATARATE DR_0

Minimal datarate that can be used by the node

## ◆ EU433_TX_MAX_DATARATE

#define EU433_TX_MAX_DATARATE DR_7

Maximal datarate that can be used by the node

## ◆ EU433_RX_MIN_DATARATE

#define EU433_RX_MIN_DATARATE DR_0

Minimal datarate that can be used by the node

## ◆ EU433_RX_MAX_DATARATE

#define EU433_RX_MAX_DATARATE DR_7

Maximal datarate that can be used by the node

## ◆ EU433_DEFAULT_DATARATE

#define EU433_DEFAULT_DATARATE DR_0

Default datarate used by the node

## ◆ EU433_MIN_RX1_DR_OFFSET

#define EU433_MIN_RX1_DR_OFFSET 0

Minimal Rx1 receive datarate offset

## ◆ EU433_MAX_RX1_DR_OFFSET

#define EU433_MAX_RX1_DR_OFFSET 5

Maximal Rx1 receive datarate offset

## ◆ EU433_DEFAULT_RX1_DR_OFFSET

#define EU433_DEFAULT_RX1_DR_OFFSET 0

Default Rx1 receive datarate offset

## ◆ EU433_MIN_TX_POWER

#define EU433_MIN_TX_POWER TX_POWER_5

Minimal Tx output power that can be used by the node

## ◆ EU433_MAX_TX_POWER

#define EU433_MAX_TX_POWER TX_POWER_0

Maximal Tx output power that can be used by the node

## ◆ EU433_DEFAULT_TX_POWER

#define EU433_DEFAULT_TX_POWER TX_POWER_0

Default Tx output power used by the node

## ◆ EU433_DEFAULT_MAX_EIRP

#define EU433_DEFAULT_MAX_EIRP 12.15f

Default Max EIRP

## ◆ EU433_DEFAULT_ANTENNA_GAIN

#define EU433_DEFAULT_ANTENNA_GAIN 2.15f

Default antenna gain

## ◆ EU433_ADR_ACK_LIMIT

#define EU433_ADR_ACK_LIMIT 64

ADR Ack limit

## ◆ EU433_ADR_ACK_DELAY

#define EU433_ADR_ACK_DELAY 32

ADR Ack delay

## ◆ EU433_DUTY_CYCLE_ENABLED

#define EU433_DUTY_CYCLE_ENABLED 1

Enabled or disabled the duty cycle

## ◆ EU433_MAX_RX_WINDOW

#define EU433_MAX_RX_WINDOW 3000

Maximum RX window duration

## ◆ EU433_RECEIVE_DELAY1

#define EU433_RECEIVE_DELAY1 1000

Receive delay 1

## ◆ EU433_RECEIVE_DELAY2

#define EU433_RECEIVE_DELAY2 2000

Receive delay 2

## ◆ EU433_JOIN_ACCEPT_DELAY1

#define EU433_JOIN_ACCEPT_DELAY1 5000

Join accept delay 1

## ◆ EU433_JOIN_ACCEPT_DELAY2

#define EU433_JOIN_ACCEPT_DELAY2 6000

Join accept delay 2

## ◆ EU433_MAX_FCNT_GAP

#define EU433_MAX_FCNT_GAP 16384

Maximum frame counter gap

## ◆ EU433_ACKTIMEOUT

#define EU433_ACKTIMEOUT 2000

Ack timeout

## ◆ EU433_ACK_TIMEOUT_RND

#define EU433_ACK_TIMEOUT_RND 1000

Random ack timeout limits

## ◆ EU433_RX_WND_2_FREQ

#define EU433_RX_WND_2_FREQ 434665000

Verification of default datarate

Second reception window channel frequency definition.

## ◆ EU433_RX_WND_2_DR

#define EU433_RX_WND_2_DR DR_0

Second reception window channel datarate definition.

## ◆ EU433_MAX_NB_BANDS

#define EU433_MAX_NB_BANDS 1

LoRaMac maximum number of bands

## ◆ EU433_BAND0

#define EU433_BAND0

Value:
{ \
100, EU433_MAX_TX_POWER, 0, 0 \
}

Band 0 definition { DutyCycle, TxMaxPower, LastTxDoneTime, TimeOff }

## ◆ EU433_LC1

#define EU433_LC1

Value:
{ \
433175000, 0, {((DR_5 << 4) | DR_0)}, 0 \
}

LoRaMac default channel 1 Channel = { Frequency [Hz], RX1 Frequency [Hz], { ( ( DrMax << 4 ) | DrMin ) }, Band }

## ◆ EU433_LC2

#define EU433_LC2

Value:
{ \
433375000, 0, {((DR_5 << 4) | DR_0)}, 0 \
}

LoRaMac default channel 2 Channel = { Frequency [Hz], RX1 Frequency [Hz], { ( ( DrMax << 4 ) | DrMin ) }, Band }

## ◆ EU433_LC3

#define EU433_LC3

Value:
{ \
433575000, 0, {((DR_5 << 4) | DR_0)}, 0 \
}

LoRaMac default channel 3 Channel = { Frequency [Hz], RX1 Frequency [Hz], { ( ( DrMax << 4 ) | DrMin ) }, Band }

## ◆ EU433_JOIN_CHANNELS

#define EU433_JOIN_CHANNELS (uint16_t)(LC(1) | LC(2) | LC(3))

LoRaMac channels which are allowed for the join procedure

## Function Documentation

## ◆ RegionEU433GetPhyParam()

PhyParam_t RegionEU433GetPhyParam | ( | GetPhyParams_t * | getPhy | ) |

The function gets a value of a specific phy attribute.

Parameters

  getPhy | Pointer to the function parameters.

Return values

  Returns | a structure containing the PHY parameter.

## ◆ RegionEU433SetBandTxDone()

void RegionEU433SetBandTxDone | ( | SetBandTxDoneParams_t * | txDone | ) |

Updates the last TX done parameters of the current channel.

Parameters

  txDone | Pointer to the function parameters.

## ◆ RegionEU433InitDefaults()

void RegionEU433InitDefaults | ( | InitType_t | type | ) |

Initializes the channels masks and the channels.

Parameters

  type | Sets the initialization type.

## ◆ RegionEU433Verify()

bool RegionEU433Verify | ( | VerifyParams_t * | verify,
|  | PhyAttribute_t | phyAttribute
| ) |  |

Verifies a parameter.

Parameters

  verify | Pointer to the function parameters.
  phyAttribute | Sets the initialization type.

Return values

  Returns | true, if the parameter is valid.

## ◆ RegionEU433ApplyCFList()

void RegionEU433ApplyCFList | ( | ApplyCFListParams_t * | applyCFList | ) |

The function parses the input buffer and sets up the channels of the CF list.

Parameters

  applyCFList | Pointer to the function parameters.

## ◆ RegionEU433ChanMaskSet()

bool RegionEU433ChanMaskSet | ( | ChanMaskSetParams_t * | chanMaskSet | ) |

Sets a channels mask.

Parameters

  chanMaskSet | Pointer to the function parameters.

Return values

  Returns | true, if the channels mask could be set.

## ◆ RegionEU433AdrNext()

bool RegionEU433AdrNext | ( | AdrNextParams_t * | adrNext,
|  | int8_t * | drOut,
|  | int8_t * | txPowOut,
|  | uint32_t * | adrAckCounter
| ) |  |

Calculates the next datarate to set, when ADR is on or off.

Parameters

  adrNext | Pointer to the function parameters.
  drOut | The calculated datarate for the next TX.
  txPowOut | The TX power for the next TX.
  adrAckCounter | The calculated ADR acknowledgement counter.

Return values

  Returns | true, if an ADR request should be performed.

## ◆ RegionEU433ComputeRxWindowParameters()

void RegionEU433ComputeRxWindowParameters | ( | int8_t | datarate,
|  | uint8_t | minRxSymbols,
|  | uint32_t | rxError,
|  | RxConfigParams_t * | rxConfigParams
| ) |  |

Computes the Rx window timeout and offset.

Parameters

  datarate | Rx window datarate index to be used
  minRxSymbols | Minimum required number of symbols to detect an Rx frame.
  rxError | System maximum timing error of the receiver. In milliseconds The receiver will turn on in a [-rxError : +rxError] ms interval around RxOffset
  rxConfigParams | Returns updated WindowTimeout and WindowOffset fields.

## ◆ RegionEU433RxConfig()

bool RegionEU433RxConfig | ( | RxConfigParams_t * | rxConfig,
|  | int8_t * | datarate
| ) |  |

Configuration of the RX windows.

Parameters

  rxConfig | Pointer to the function parameters.
  datarate | The datarate index which was set.

Return values

  Returns | true, if the configuration was applied successfully.

## ◆ RegionEU433TxConfig()

bool RegionEU433TxConfig | ( | TxConfigParams_t * | txConfig,
|  | int8_t * | txPower,
|  | TimerTime_t * | txTimeOnAir
| ) |  |

TX configuration.

Parameters

  txConfig | Pointer to the function parameters.
  txPower | The tx power index which was set.
  txTimeOnAir | The time-on-air of the frame.

Return values

  Returns | true, if the configuration was applied successfully.

## ◆ RegionEU433LinkAdrReq()

uint8_t RegionEU433LinkAdrReq | ( | LinkAdrReqParams_t * | linkAdrReq,
|  | int8_t * | drOut,
|  | int8_t * | txPowOut,
|  | uint8_t * | nbRepOut,
|  | uint8_t * | nbBytesParsed
| ) |  |

The function processes a Link ADR Request.

Parameters

  linkAdrReq | Pointer to the function parameters.
  drOut | Data rate.
  txPowOut | TX power.
  nbRepOut | Number of repeats.
  nbBytesParsed | Number of parsed bytes.

Return values

  Returns | the status of the operation, according to the LoRaMAC specification.

## ◆ RegionEU433RxParamSetupReq()

uint8_t RegionEU433RxParamSetupReq | ( | RxParamSetupReqParams_t * | rxParamSetupReq | ) |

The function processes a RX Parameter Setup Request.

Parameters

  rxParamSetupReq | Pointer to the function parameters.

Return values

  Returns | the status of the operation, according to the LoRaMAC specification.

## ◆ RegionEU433NewChannelReq()

uint8_t RegionEU433NewChannelReq | ( | NewChannelReqParams_t * | newChannelReq | ) |

The function processes a Channel Request.

Parameters

  newChannelReq | Pointer to the function parameters.

Return values

  Returns | the status of the operation, according to the LoRaMAC specification.

## ◆ RegionEU433TxParamSetupReq()

int8_t RegionEU433TxParamSetupReq | ( | TxParamSetupReqParams_t * | txParamSetupReq | ) |

The function processes a TX ParamSetup Request.

Parameters

  txParamSetupReq | Pointer to the function parameters.

Return values

  Returns | the status of the operation, according to the LoRaMAC specification. Returns -1, if the functionality is not implemented. In this case, the end node shall not process the command.

## ◆ RegionEU433DlChannelReq()

uint8_t RegionEU433DlChannelReq | ( | DlChannelReqParams_t * | dlChannelReq | ) |

The function processes a DlChannel Request.

Parameters

  dlChannelReq | Pointer to the function parameters.

Return values

  Returns | the status of the operation, according to the LoRaMAC specification.

## ◆ RegionEU433AlternateDr()

int8_t RegionEU433AlternateDr | ( | AlternateDrParams_t * | alternateDr | ) |

Alternates the datarate of the channel for the join request.

Parameters

  alternateDr | Pointer to the function parameters.

Return values

  Datarate | to apply.

## ◆ RegionEU433CalcBackOff()

void RegionEU433CalcBackOff | ( | CalcBackOffParams_t * | calcBackOff | ) |

Calculates the back-off time.

Parameters

  calcBackOff | Pointer to the function parameters.

## ◆ RegionEU433NextChannel()

bool RegionEU433NextChannel | ( | NextChanParams_t * | nextChanParams,
|  | uint8_t * | channel,
|  | TimerTime_t * | time,
|  | TimerTime_t * | aggregatedTimeOff
| ) |  |

Searches and set the next random available channel.

Parameters

  nextChanParams | Parameters of next channel to use for TX.
  channel | Next channel to use for TX.
  time | Time to wait for the next transmission according to the duty cycle.
  aggregatedTimeOff | Updates the aggregated time off.

Return values

  Function | status [1: OK, 0: Unable to find a channel on the current datarate]

## ◆ RegionEU433ChannelAdd()

LoRaMacStatus_t RegionEU433ChannelAdd | ( | ChannelAddParams_t * | channelAdd | ) |

Adds a channel.

Parameters

  channelAdd | Pointer to the function parameters.

Return values

  Status | of the operation.

## ◆ RegionEU433ChannelsRemove()

bool RegionEU433ChannelsRemove | ( | ChannelRemoveParams_t * | channelRemove | ) |

Removes a channel.

Parameters

  channelRemove | Pointer to the function parameters.

Return values

  Returns | true, if the channel was removed successfully.

## ◆ RegionEU433SetContinuousWave()

void RegionEU433SetContinuousWave | ( | ContinuousWaveParams_t * | continuousWave | ) |

Sets the radio into continuous wave mode.

Parameters

  continuousWave | Pointer to the function parameters.

## ◆ RegionEU433ApplyDrOffset()

uint8_t RegionEU433ApplyDrOffset | ( | uint8_t | downlinkDwellTime,
|  | int8_t | dr,
|  | int8_t | drOffset
| ) |  |

Computes new datarate according to the given offset.

Parameters

  downlinkDwellTime | Downlink dwell time configuration. 0: No limit, 1: 400ms
  dr | Current datarate
  drOffset | Offset to be applied

Return values

  newDr | Computed datarate.

## Variable Documentation

## ◆ DataratesEU433

const uint8_t DataratesEU433[] = {12, 11, 10, 9, 8, 7, 7, 50}
| static

Data rates table definition

## ◆ BandwidthsEU433

const uint32_t BandwidthsEU433[] = {125000, 125000, 125000, 125000, 125000, 125000, 250000, 0}
| static

Bandwidths table definition in Hz

## ◆ MaxPayloadOfDatarateEU433

const uint8_t MaxPayloadOfDatarateEU433[] = {51, 51, 51, 115, 242, 242, 242, 242}
| static

Maximum payload with respect to the datarate index. Cannot operate with repeater.

## ◆ MaxPayloadOfDatarateRepeaterEU433

const uint8_t MaxPayloadOfDatarateRepeaterEU433[] = {51, 51, 51, 115, 222, 222, 222, 222}
| static

Maximum payload with respect to the datarate index. Can operate with repeater.

EU433_MAX_TX_POWER
#define EU433_MAX_TX_POWER
Definition: RegionEU433.h:104
DR_5
#define DR_5
Definition: Region.h:179
DR_0
#define DR_0
Definition: Region.h:84